part of mapmyindia_nearby_plugin;

class CategoryCode {
  /// To set the name to display the category
  final String category;

  /// Icon to show in list
  final Uint8List icon;

  /// Category codes used to search the category
  final List<String> categoryCode;

  /// To set the marker icon to show on map
  final Uint8List markerIcon;

  /// To set the category is selected or not
  bool isSelected;

  CategoryCode(this.category, this.icon, this.categoryCode, this.markerIcon,
      {this.isSelected = false});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('category', category);
    addIfNonNull('icon', icon);
    addIfNonNull('categoryCode', categoryCode);
    addIfNonNull('markerIcon', markerIcon);
    addIfNonNull('isSelected', isSelected);

    return optionsMap;
  }
}
