part of mapmyindia_nearby_plugin;

/// This class is used to set the Nearby API request setting
class NearbyOption {
  /// To set the radius used to get results in the provided radius
  final int? radius;

  /// To get the results in the provided bound
  final String? bounds;

  final bool? explain;

  /// To set the filter for search
  final String? filter;

  /// To set the pod in Nearby Request
  final String? pod;

  /// To get the rich data in the response
  final bool? richData;

  /// Provides the configuration for search
  final String? searchBy;

  /// provides configured sorting operations for the client on cloud.
  final String? sortBy;

  /// To bound the result for user
  final String? userName;

  NearbyOption(
      {this.radius,
      this.bounds,
      this.explain,
      this.filter,
      this.pod,
      this.richData,
      this.searchBy,
      this.sortBy,
      this.userName});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('radius', radius);
    addIfNonNull('bounds', bounds);
    addIfNonNull('explain', explain);
    addIfNonNull('filter', filter);
    addIfNonNull('pod', pod);
    addIfNonNull('richData', richData);
    addIfNonNull('searchBy', searchBy);
    addIfNonNull('sortBy', sortBy);
    addIfNonNull('userName', userName);

    return optionsMap;
  }
}
